#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <json-c/json.h>

#include "test_notification.h"
#include "zw_api.h"
#include "../alarm_meaning.h"

table_parser_t test_case_notification[]=
{
    //Smoke alarm
    {0x01,0x00,0x00,0x00, ST_ALARM_MEANING_SMOKE_STATE_IDLE},
    {0x01,0x01,0x00,0x00, ST_ALARM_MEANING_SMOKE_DETECTED},
    {0x01,0x01,0x01,0x61, "smoke detected at location a"},
    {0x01,0x02,0x00,0x00, ST_ALARM_MEANING_SMOKE_DETECTED},
    {0x01,0x02,0x01,0x61, ST_ALARM_MEANING_SMOKE_DETECTED},
    {0x01,0x03,0x00,0x00, ST_ALARM_MEANING_SMOKE_ALARM_TEST},
    {0x01,0x03,0x01,0x61, ST_ALARM_MEANING_SMOKE_ALARM_TEST},
    {0x01,0x04,0x01,0x61, ST_ALARM_MEANING_SMOKE_REPLACEMENT_REQUIRED},
    {0x01,0x05,0x00,0x00, ST_ALARM_MEANING_SMOKE_REPLACEMENT_REQUIRED_EOL},
    {0x01,0x05,0x01,0x61, ST_ALARM_MEANING_SMOKE_REPLACEMENT_REQUIRED_EOL},
    {0x01,0x06,0x00,0x00, ST_ALARM_MEANING_SMOKE_ALARM_SILENCED},
    {0x01,0x06,0x01,0x61, ST_ALARM_MEANING_SMOKE_ALARM_SILENCED},
    {0x01,0x07,0x00,0x00, ST_ALARM_MEANING_SMOKE_MAINTENANCE_REQUIRED_PPI},
    {0x01,0x07,0x01,0x61, ST_ALARM_MEANING_SMOKE_MAINTENANCE_REQUIRED_PPI},
    {0x01,0x08,0x00,0x00, ST_ALARM_MEANING_SMOKE_MAINTENANCE_REQUIRED_DID},
    {0x01,0x09,0x00,0x00, "unknown"},
    {0x01,0x0A,0x01,0x61, "unknown"},
    {0x01,0xFE,0x00,0x00, ST_ALARM_MEANING_SMOKE_UNKHOWN_EVENT_STATE},
    {0x01,0xFF,0x01,0x61, "unknown"},
    //CO alarm
    {0x02,0x00,0x00,0x00, ST_ALARM_MEANING_CO_STATE_IDLE},
    {0x02,0x01,0x00,0x00, ST_ALARM_MEANING_CO_DETECTED},
    {0x02,0x01,0x01,0x61, "carbon monoxide detected at location a"},
    {0x02,0x02,0x00,0x00, ST_ALARM_MEANING_CO_DETECTED},
    {0x02,0x02,0x01,0x61, ST_ALARM_MEANING_CO_DETECTED},
    {0x02,0x03,0x00,0x00, ST_ALARM_MEANING_CO_TEST},
    {0x02,0x03,0x01,0x01, ST_ALARM_MEANING_CO_TEST_OK},
    {0x02,0x03,0x01,0x02, ST_ALARM_MEANING_CO_TEST_FAILED},
    {0x02,0x03,0x01,0x62, "unknown"},
    {0x02,0x04,0x00,0x00, ST_ALARM_MEANING_CO_REPLACEMENT_REQUIRED},
    {0x02,0x04,0x01,0x61, ST_ALARM_MEANING_CO_REPLACEMENT_REQUIRED},
    {0x02,0x05,0x00,0x00, ST_ALARM_MEANING_CO_REPLACEMENT_REQUIRED_EOL},
    {0x02,0x05,0x01,0x61, ST_ALARM_MEANING_CO_REPLACEMENT_REQUIRED_EOL},
    {0x02,0x06,0x00,0x00, ST_ALARM_MEANING_CO_ALARM_SILENCED},
    {0x02,0x06,0x01,0x61, ST_ALARM_MEANING_CO_ALARM_SILENCED},
    {0x02,0x07,0x00,0x00, ST_ALARM_MEANING_CO_MAINTENANCE_REQUIRED_PPI},
    {0x02,0x07,0x01,0x61, ST_ALARM_MEANING_CO_MAINTENANCE_REQUIRED_PPI},
    {0x02,0x08,0x00,0x00, "unknown"},
    {0x02,0x09,0x00,0x00, "unknown"},
    {0x02,0x0A,0x01,0x61, "unknown"},
    {0x02,0xFE,0x00,0x00, ST_ALARM_MEANING_CO_UNKHOWN_EVENT_STATE},
    {0x02,0xFF,0x01,0x61, "unknown"},
    //CO2 Alarm
    {0x03,0x00,0x00,0x00, ST_ALARM_MEANING_CO2_STATE_IDLE},
    {0x03,0x01,0x00,0x00, ST_ALARM_MEANING_CO2_DETECTED},
    {0x03,0x01,0x01,0x61, "carbon dioxide detected at location a"},
    {0x03,0x02,0x00,0x00, ST_ALARM_MEANING_CO2_DETECTED},
    {0x03,0x02,0x01,0x61, ST_ALARM_MEANING_CO2_DETECTED},
    {0x03,0x03,0x00,0x00, ST_ALARM_MEANING_CO2_TEST},
    {0x03,0x03,0x01,0x01, ST_ALARM_MEANING_CO2_TEST_OK},
    {0x03,0x03,0x01,0x02, ST_ALARM_MEANING_CO2_TEST_FAILED},
    {0x03,0x03,0x01,0x61, "unknown"},
    {0x03,0x04,0x00,0x00, ST_ALARM_MEANING_CO2_REPLACEMENT_REQUIRED},
    {0x03,0x04,0x01,0x61, ST_ALARM_MEANING_CO2_REPLACEMENT_REQUIRED},
    {0x03,0x05,0x00,0x00, ST_ALARM_MEANING_CO2_REPLACEMENT_REQUIRED_EOL},
    {0x03,0x05,0x01,0x61, ST_ALARM_MEANING_CO2_REPLACEMENT_REQUIRED_EOL},
    {0x03,0x06,0x00,0x00, ST_ALARM_MEANING_CO2_ALARM_SILENCED},
    {0x03,0x06,0x01,0x61, ST_ALARM_MEANING_CO2_ALARM_SILENCED},
    {0x03,0x07,0x00,0x00, ST_ALARM_MEANING_CO2_MAINTENANCE_REQUIRED_PPI},
    {0x03,0x07,0x01,0x61, ST_ALARM_MEANING_CO2_MAINTENANCE_REQUIRED_PPI},
    {0x03,0x08,0x00,0x00, "unknown"},
    {0x03,0x09,0x00,0x00, "unknown"},
    {0x03,0x0A,0x01,0x61, "unknown"},
    {0x03,0xFE,0x00,0x00, ST_ALARM_MEANING_CO2_UNKHOWN_EVENT_STATE},
    {0x03,0xFF,0x01,0x61, "unknown"},
    //HEAT Alarm
    {0x04,0x00,0x00,0x00, ST_ALARM_MEANING_HEAT_STATE_IDLE},
    {0x04,0x01,0x00,0x00, ST_ALARM_MEANING_HEAT_OVERHEAT_DETECTED},
    {0x04,0x01,0x01,0x61, "overheat detected at location a"},
    {0x04,0x02,0x00,0x00, ST_ALARM_MEANING_HEAT_OVERHEAT_DETECTED},
    {0x04,0x02,0x01,0x61, ST_ALARM_MEANING_HEAT_OVERHEAT_DETECTED},
    {0x04,0x03,0x00,0x00, ST_ALARM_MEANING_HEAT_RAPID_TEMPERATURE_RISE},
    {0x04,0x03,0x01,0x61, "rapid temperature rise at location a"},
    {0x04,0x04,0x00,0x00, ST_ALARM_MEANING_HEAT_RAPID_TEMPERATURE_RISE},
    {0x04,0x04,0x01,0x61, ST_ALARM_MEANING_HEAT_RAPID_TEMPERATURE_RISE},
    {0x04,0x05,0x00,0x00, ST_ALARM_MEANING_HEAT_UNDER_HEAT_DETECTED},
    {0x04,0x05,0x01,0x61, "under heat detected at location a"},
    {0x04,0x06,0x00,0x00, ST_ALARM_MEANING_HEAT_UNDER_HEAT_DETECTED},
    {0x04,0x06,0x01,0x61, ST_ALARM_MEANING_HEAT_UNDER_HEAT_DETECTED},
    {0x04,0x07,0x00,0x00, ST_ALARM_MEANING_HEAT_ALARM_TEST},
    {0x04,0x07,0x01,0x61, ST_ALARM_MEANING_HEAT_ALARM_TEST},
    {0x04,0x08,0x00,0x00, ST_ALARM_MEANING_HEAT_REPLACEMENT_REQUIRED_EOL},
    {0x04,0x08,0x01,0x61, ST_ALARM_MEANING_HEAT_REPLACEMENT_REQUIRED_EOL},
    {0x04,0x09,0x00,0x00, ST_ALARM_MEANING_HEAT_ALARM_SILENCED},
    {0x04,0x09,0x01,0x61, ST_ALARM_MEANING_HEAT_ALARM_SILENCED},
    {0x04,0x0A,0x00,0x00, ST_ALARM_MEANING_HEAT_MAINTENANCE_REQUIRED_DID},  
    {0x04,0x0A,0x01,0x61, ST_ALARM_MEANING_HEAT_MAINTENANCE_REQUIRED_DID},
    {0x04,0x0B,0x00,0x00, ST_ALARM_MEANING_HEAT_MAINTENANCE_REQUIRED_PPI},
    {0x04,0x0B,0x01,0x61, ST_ALARM_MEANING_HEAT_MAINTENANCE_REQUIRED_PPI},
    {0x04,0x0C,0x00,0x00, ST_ALARM_MEANING_HEAT_RAPID_TEMPERATURE_FALL},
    {0x04,0x0C,0x01,0x61, "rapid temperature fall at location a"},
    {0x04,0x0D,0x00,0x00, ST_ALARM_MEANING_HEAT_RAPID_TEMPERATURE_FALL},
    {0x04,0x0D,0x00,0x00, ST_ALARM_MEANING_HEAT_RAPID_TEMPERATURE_FALL},
    {0x04,0x0E,0x00,0x00, "unknown"},
    {0x04,0xFE,0x01,0x61, ST_ALARM_MEANING_HEAT_UNKHOWN_EVENT_STATE},
    {0x04,0xFF,0x01,0x61, "unknown"},
    //WATER Alarm
    {0x05,0x00,0x00,0x00, ST_ALARM_MEANING_WATER_STATE_IDLE},
    {0x05,0x01,0x00,0x00, ST_ALARM_MEANING_WATER_LEAK_DETECTED_LOCATION},
    {0x05,0x01,0x01,0x61, "water leak detected at location a"},
    {0x05,0x02,0x00,0x00, ST_ALARM_MEANING_WATER_LEAK_DETECTED},
    {0x05,0x02,0x01,0x61, ST_ALARM_MEANING_WATER_LEAK_DETECTED},
    {0x05,0x03,0x00,0x00, ST_ALARM_MEANING_WATER_LEVEL_DROPPED_LOCATION},
    {0x05,0x03,0x01,0x61, "water level dropped at location a"},
    {0x05,0x04,0x00,0x00, ST_ALARM_MEANING_WATER_LEVEL_DROPPED},
    {0x05,0x04,0x01,0x61, ST_ALARM_MEANING_WATER_LEVEL_DROPPED},
    {0x05,0x05,0x00,0x00, ST_ALARM_MEANING_WATER_REPLACE_WATER_FILTER},
    {0x05,0x05,0x01,0x61, ST_ALARM_MEANING_WATER_REPLACE_WATER_FILTER},
    {0x05,0x06,0x00,0x00, ST_ALARM_MEANING_WATER_FLOW_ALARM},
    {0x05,0x06,0x01,0x01, ST_ALARM_MEANING_WATER_FLOW_ALARM_NODATA},
    {0x05,0x06,0x01,0x02, ST_ALARM_MEANING_WATER_FLOW_ALARM_LOW_THRESHOLD},
    {0x05,0x06,0x01,0x03, ST_ALARM_MEANING_WATER_FLOW_ALARM_HIGH_THRESHOLD},
    {0x05,0x06,0x01,0x04, ST_ALARM_MEANING_WATER_FLOW_ALARM_MAX},
    {0x05,0x06,0x01,0x05, "unknown"},
    {0x05,0x06,0x01,0xFF, "unknown"},
    {0x05,0x07,0x00,0x00, ST_ALARM_MEANING_WATER_PRESSURE_ALARM},
    {0x05,0x07,0x01,0x01, ST_ALARM_MEANING_WATER_PRESSURE_ALARM_NODATA},
    {0x05,0x07,0x00,0x01, ST_ALARM_MEANING_WATER_PRESSURE_ALARM},
    {0x05,0x07,0x01,0x02, ST_ALARM_MEANING_WATER_PRESSURE_ALARM_LOW_THRESHOLD},
    {0x05,0x07,0x01,0x03, ST_ALARM_MEANING_WATER_PRESSURE_ALARM_HIGH_THRESHOLD},
    {0x05,0x07,0x01,0x04, ST_ALARM_MEANING_WATER_PRESSURE_ALARM_MAX},
    {0x05,0x07,0x00,0xFF, ST_ALARM_MEANING_WATER_PRESSURE_ALARM},
    {0x05,0x08,0x00,0x00, ST_ALARM_MEANING_WATER_TEMPERATURE_ALARM},
    {0x05,0x08,0x01,0x01, ST_ALARM_MEANING_WATER_TEMPERATURE_ALARM_NODATA},
    {0x05,0x08,0x01,0x02, ST_ALARM_MEANING_WATER_TEMPERATURE_ALARM_LOW_THRESHOLD},
    {0x05,0x08,0x01,0x03, ST_ALARM_MEANING_WATER_TEMPERATURE_ALARM_HIGH_THRESHOLD},
    {0x05,0x08,0x01,0x04, "unknown"},
    {0x05,0x08,0x01,0xFF, "unknown"},
    {0x05,0x09,0x00,0x00, ST_ALARM_MEANING_WATER_LEVEL_ALARM},
    {0x05,0x09,0x01,0x01, ST_ALARM_MEANING_WATER_LEVEL_ALARM_NODATA},
    {0x05,0x09,0x00,0x01, ST_ALARM_MEANING_WATER_LEVEL_ALARM},
    {0x05,0x09,0x01,0x02, ST_ALARM_MEANING_WATER_LEVEL_ALARM_LOW_THRESHOLD},
    {0x05,0x09,0x01,0x03, ST_ALARM_MEANING_WATER_LEVEL_ALARM_HIGH_THRESHOLD},
    {0x05,0x09,0x01,0xFF, "unknown"},     
    {0x05,0x0A,0x00,0x00, ST_ALARM_MEANING_WATER_SUMP_PUMP_ACTIVE},  
    {0x05,0x0A,0x01,0x61, ST_ALARM_MEANING_WATER_SUMP_PUMP_ACTIVE},
    {0x05,0x0B,0x00,0x00, ST_ALARM_MEANING_WATER_SUMP_PUMP_FAILURE},
    {0x05,0x0B,0x01,0x61, ST_ALARM_MEANING_WATER_SUMP_PUMP_FAILURE},
    {0x05,0x0C,0x00,0x00, "unknown"},
    {0x05,0x0C,0x01,0x61, "unknown"},
    {0x05,0x0E,0x00,0x00, "unknown"},
    {0x05,0xFE,0x00,0x00, ST_ALARM_MEANING_WATER_UNKHOWN_EVENT_STATE},
    {0x05,0xFE,0x01,0x61, ST_ALARM_MEANING_WATER_UNKHOWN_EVENT_STATE},
    {0x05,0xFF,0x01,0x61, "unknown"},
    // ACCESS CONTROL
    {0x06,0x00,0x00,0x00, ST_ALARM_MEANING_AC_STATE_IDLE},
    {0x06,0x01,0x00,0x00, ST_ALARM_MEANING_AC_MANUAL_LOCK_OPERATION},
    {0x06,0x01,0x01,0x61, ST_ALARM_MEANING_AC_MANUAL_LOCK_OPERATION},
    {0x06,0x02,0x00,0x00, ST_ALARM_MEANING_AC_MANUAL_UNLOCK_OPERATION},
    {0x06,0x02,0x01,0x61, ST_ALARM_MEANING_AC_MANUAL_UNLOCK_OPERATION},
    {0x06,0x03,0x00,0x00, ST_ALARM_MEANING_AC_RF_LOCK_OPERATION},
    {0x06,0x03,0x01,0x61, ST_ALARM_MEANING_AC_RF_LOCK_OPERATION},
    {0x06,0x04,0x00,0x00, ST_ALARM_MEANING_AC_RF_UNLOCK_OPERATION},
    {0x06,0x04,0x01,0x61, ST_ALARM_MEANING_AC_RF_UNLOCK_OPERATION},
    {0x06,0x05,0x00,0x00, ST_ALARM_MEANING_AC_KEYPAD_LOCK_OPERATION},
    {0x06,0x05,0x01,0x61, ST_ALARM_MEANING_AC_KEYPAD_LOCK_OPERATION},
    {0x06,0x06,0x00,0x00, ST_ALARM_MEANING_AC_KEYPAD_UNLOCK_OPERATION},
    {0x06,0x06,0x01,0x61, ST_ALARM_MEANING_AC_KEYPAD_UNLOCK_OPERATION},
    {0x06,0x07,0x00,0x00, ST_ALARM_MEANING_AC_MANUAL_NOT_FULLY_LOCKED_OPERATION},
    {0x06,0x07,0x01,0x61, ST_ALARM_MEANING_AC_MANUAL_NOT_FULLY_LOCKED_OPERATION},
    {0x06,0x08,0x00,0x00, ST_ALARM_MEANING_AC_RF_NOT_FULLY_LOCKED_OPERATION},
    {0x06,0x08,0x01,0x61, ST_ALARM_MEANING_AC_RF_NOT_FULLY_LOCKED_OPERATION},
    {0x06,0x09,0x00,0x00, ST_ALARM_MEANING_AC_AUTO_LOCK_LOCKED_OPERATION},
    {0x06,0x09,0x01,0x61, ST_ALARM_MEANING_AC_AUTO_LOCK_LOCKED_OPERATION},     
    {0x06,0x0A,0x00,0x00, ST_ALARM_MEANING_AC_AUTO_LOCK_NOT_FULLY_LOCKED_OPERATION},  
    {0x06,0x0A,0x01,0x61, ST_ALARM_MEANING_AC_AUTO_LOCK_NOT_FULLY_LOCKED_OPERATION},
    {0x06,0x0B,0x00,0x00, ST_ALARM_MEANING_AC_LOCK_JAMMED},
    {0x06,0x0B,0x01,0x61, ST_ALARM_MEANING_AC_LOCK_JAMMED},
    {0x06,0x0C,0x00,0x00, ST_ALARM_MEANING_AC_ALL_USER_CODE_DELETED},
    {0x06,0x0C,0x01,0x61, ST_ALARM_MEANING_AC_ALL_USER_CODE_DELETED},
    {0x06,0x0D,0x00,0x00, ST_ALARM_MEANING_AC_SINGLE_USER_CODE_DELETED},
    {0x06,0x0D,0x01,0x61, ST_ALARM_MEANING_AC_SINGLE_USER_CODE_DELETED},
    {0x06,0x0E,0x00,0x00, ST_ALARM_MEANING_AC_NEW_USER_CODE_ADDED},
    {0x06,0x0E,0x01,0x61, ST_ALARM_MEANING_AC_NEW_USER_CODE_ADDED},
    {0x06,0x0F,0x00,0x00, ST_ALARM_MEANING_AC_NEW_USER_CODE_NOT_ADDED},
    {0x06,0x0F,0x01,0x61, ST_ALARM_MEANING_AC_NEW_USER_CODE_NOT_ADDED},
    {0x06,0x10,0x00,0x00, ST_ALARM_MEANING_AC_KEYPAD_TEMPORARY_DISABLED},
    {0x06,0x10,0x01,0x61, ST_ALARM_MEANING_AC_KEYPAD_TEMPORARY_DISABLED},
    {0x06,0x11,0x00,0x00, ST_ALARM_MEANING_AC_KEYPAD_BUSY},
    {0x06,0x11,0x01,0x61, ST_ALARM_MEANING_AC_KEYPAD_BUSY},
    {0x06,0x12,0x00,0x00, ST_ALARM_MEANING_AC_NEW_PROGRAM_CODE_ENTERED},
    {0x06,0x12,0x01,0x61, ST_ALARM_MEANING_AC_NEW_PROGRAM_CODE_ENTERED},
    {0x06,0x13,0x00,0x00, ST_ALARM_MEANING_AC_MANUALY_ENTER_USER_ACCESS_CODE_EXCEEDED},
    {0x06,0x13,0x01,0x61, ST_ALARM_MEANING_AC_MANUALY_ENTER_USER_ACCESS_CODE_EXCEEDED},
    {0x06,0x14,0x00,0x00, ST_ALARM_MEANING_AC_UNLOCK_RF_INVALID_USER_CODE},
    {0x06,0x14,0x01,0x61, ST_ALARM_MEANING_AC_UNLOCK_RF_INVALID_USER_CODE},
    {0x06,0x15,0x00,0x00, ST_ALARM_MEANING_AC_LOCKED_RF_INVALID_USER_CODE},
    {0x06,0x15,0x01,0x61, ST_ALARM_MEANING_AC_LOCKED_RF_INVALID_USER_CODE},
    {0x06,0x16,0x00,0x00, ST_ALARM_MEANING_AC_WINDOW_DOOR_OPEN},
    {0x06,0x16,0x01,0x61, ST_ALARM_MEANING_AC_WINDOW_DOOR_OPEN},
    {0x06,0x17,0x00,0x00, ST_ALARM_MEANING_AC_WINDOW_DOOR_CLOSED},
    {0x06,0x17,0x01,0x61, ST_ALARM_MEANING_AC_WINDOW_DOOR_CLOSED},
    {0x06,0x18,0x00,0x00, ST_ALARM_MEANING_AC_WINDOW_DOOR_HANDLE_OPEN},
    {0x06,0x18,0x01,0x61, ST_ALARM_MEANING_AC_WINDOW_DOOR_HANDLE_OPEN},
    {0x06,0x19,0x00,0x00, ST_ALARM_MEANING_AC_WINDOW_DOOR_HANDLE_CLOSED},
    {0x06,0x19,0x01,0x61, ST_ALARM_MEANING_AC_WINDOW_DOOR_HANDLE_CLOSED},
    {0x06,0x40,0x00,0x00, "unknown"},
    {0x06,0x40,0x01,0x00, ST_ALARM_MEANING_AC_BARRIER_PERFORMING_INIT_PROCESS_COMPLETED},
    {0x06,0x40,0x00,0xFF, "unknown"},
    {0x06,0x40,0x01,0xFF, ST_ALARM_MEANING_AC_BARRIER_PERFORMING_INIT_PROCESS_PERFORMING},
    {0x06,0x40,0x01,0x61, "unknown"},
    {0x06,0x41,0x00,0x00, ST_ALARM_MEANING_AC_BARRIER_OPERATION_FORCE_EXCEEDED},
    {0x06,0x41,0x01,0x61, ST_ALARM_MEANING_AC_BARRIER_OPERATION_FORCE_EXCEEDED},
    {0x06,0x42,0x00,0x00, ST_ALARM_MEANING_AC_BARRIER_MOTOR_EXCEEDED},
    {0x06,0x42,0x01,0x01, "barrier motor has exceeded manufacture's operational time limit 1 seconds"},
    {0x06,0x42,0x01,0x7F, "barrier motor has exceeded manufacture's operational time limit 127 seconds"},
    {0x06,0x42,0x01,0x80, "barrier motor has exceeded manufacture's operational time limit 1 minutes"},
    {0x06,0x42,0x01,0xFF, ST_ALARM_MEANING_AC_BARRIER_MOTOR_EXCEEDED},
    {0x06,0x43,0x00,0x00, ST_ALARM_MEANING_AC_BARRIER_OPERATION_PHYSICAL_EXCEEDED},
    {0x06,0x43,0x01,0x61, ST_ALARM_MEANING_AC_BARRIER_OPERATION_PHYSICAL_EXCEEDED},
    {0x06,0x44,0x00,0x00, ST_ALARM_MEANING_AC_BARRIER_UNABLE_PERFORM_REQUEST},
    {0x06,0x44,0x01,0x61, ST_ALARM_MEANING_AC_BARRIER_UNABLE_PERFORM_REQUEST},
    {0x06,0x45,0x00,0x00, ST_ALARM_MEANING_AC_BARRIER_UNATTENDED_DISABLED},
    {0x06,0x45,0x01,0x61, ST_ALARM_MEANING_AC_BARRIER_UNATTENDED_DISABLED},
    {0x06,0x46,0x00,0x00, ST_ALARM_MEANING_AC_BARRIER_MALFUNCTION},
    {0x06,0x46,0x01,0x61, ST_ALARM_MEANING_AC_BARRIER_MALFUNCTION},
    {0x06,0x47,0x01,0x00, ST_ALARM_MEANING_AC_BARRIER_VACATION_MODE_DISABLE},
    {0x06,0x47,0x01,0x01, "unknown"},
    {0x06,0x47,0x01,0x02, "unknown"},
    {0x06,0x47,0x01,0xFF, ST_ALARM_MEANING_AC_BARRIER_VACATION_MODE_ENABLE},
    {0x06,0x48,0x01,0x00, ST_ALARM_MEANING_AC_BARRIER_SAFETY_BEAM_OBSTACLE_NO_OBSTRUCTION},
    {0x06,0x48,0x01,0x01, "unknown"},
    {0x06,0x48,0x01,0x02, "unknown"},
    {0x06,0x48,0x01,0xFF, ST_ALARM_MEANING_AC_BARRIER_SAFETY_BEAM_OBSTACLE_OBSTRUCTION},
    {0x06,0x49,0x00,0x00, ST_ALARM_MEANING_AC_BARRIER_SENSOR_NOT_DETECTED},
    {0x06,0x49,0x01,0x00, ST_ALARM_MEANING_AC_BARRIER_SENSOR_NOT_DETECTED},
    {0x06,0x49,0x01,0x01, "barrier sensor not detected with sensorId: 1"},
    {0x06,0x49,0x01,0xFF, "barrier sensor not detected with sensorId: 255"},
    {0x06,0x4A,0x00,0x00, ST_ALARM_MEANING_AC_BARRIER_SENSOR_LOW_BATTERY_WARNING},
    {0x06,0x4A,0x01,0x01, "barrier sensor low battery warning with sensorId: 1"},
    {0x06,0x4A,0x01,0xFF, "barrier sensor low battery warning with sensorId: 255"},
    {0x06,0x4B,0x00,0x00, ST_ALARM_MEANING_AC_BARRIER_DETECTED_SHORT},
    {0x06,0x4B,0x01,0x61, ST_ALARM_MEANING_AC_BARRIER_DETECTED_SHORT},
    {0x06,0x4C,0x00,0x00, ST_ALARM_MEANING_AC_BARRIER_ASSOCIATED_WITH_NON_ZWAVE_REMOTE},
    {0x06,0x4C,0x01,0x61, ST_ALARM_MEANING_AC_BARRIER_ASSOCIATED_WITH_NON_ZWAVE_REMOTE},
    {0x06,0xFE,0x00,0x00, ST_ALARM_MEANING_AC_UNKHOWN_EVENT_STATE},
    {0x06,0xFF,0x01,0x61, "unknown"},
    //Home sercurity
    {0x07,0x00,0x00,0x00, ST_ALARM_MEANING_HOME_STATE_IDLE},
    {0x07,0x01,0x00,0x00, ST_ALARM_MEANING_HOME_INTRUSION_LOCATION},
    {0x07,0x01,0x01,0x61, "intrusion at location a"},
    {0x07,0x02,0x00,0x00, ST_ALARM_MEANING_HOME_INTRUSION},
    {0x07,0x02,0x01,0x61, ST_ALARM_MEANING_HOME_INTRUSION},
    {0x07,0x03,0x00,0x00, ST_ALARM_MEANING_HOME_TEMPERATING_PRODUCT_REMOVE},
    {0x07,0x03,0x01,0x61, ST_ALARM_MEANING_HOME_TEMPERATING_PRODUCT_REMOVE},
    {0x07,0x04,0x00,0x00, ST_ALARM_MEANING_HOME_TEMPERATING_INVALID_CODE},
    {0x07,0x04,0x01,0x61, ST_ALARM_MEANING_HOME_TEMPERATING_INVALID_CODE},
    {0x07,0x05,0x00,0x00, ST_ALARM_MEANING_HOME_GLASS_BREAKAGE_LOCATION},
    {0x07,0x05,0x01,0x61, "glass breakage at location a"},
    {0x07,0x06,0x00,0x00, ST_ALARM_MEANING_HOME_GLASS_BREAKAGE},
    {0x07,0x06,0x01,0x61, ST_ALARM_MEANING_HOME_GLASS_BREAKAGE},
    {0x07,0x07,0x00,0x00, ST_ALARM_MEANING_HOME_MOTION_DETECTION_LOCATION},
    {0x07,0x07,0x01,0x61, "motion detected at location a"},
    {0x07,0x08,0x00,0x00, ST_ALARM_MEANING_HOME_MOTION_DETECTION},
    {0x07,0x08,0x01,0x61, ST_ALARM_MEANING_HOME_MOTION_DETECTION},
    {0x07,0x09,0x00,0x00, ST_ALARM_MEANING_HOME_TEMPERATING_MOVED},
    {0x07,0x09,0x01,0xFF, ST_ALARM_MEANING_HOME_TEMPERATING_MOVED},     
    {0x07,0xFE,0x00,0x00, ST_ALARM_MEANING_HOME_UNKHOWN_EVENT_STATE},  
    {0x07,0xFE,0x01,0x61, ST_ALARM_MEANING_HOME_UNKHOWN_EVENT_STATE},
    {0x07,0xFF,0x00,0x00, "unknown"},
    //Power Management
    {0x08,0x00,0x00,0x00, ST_ALARM_MEANING_PM_STATE_IDLE},
    {0x08,0x01,0x00,0x00, ST_ALARM_MEANING_PM_POWER_APPLIED},
    {0x08,0x01,0x01,0x61, ST_ALARM_MEANING_PM_POWER_APPLIED},
    {0x08,0x02,0x00,0x00, ST_ALARM_MEANING_PM_AC_DISCONNECTED},
    {0x08,0x02,0x01,0x61, ST_ALARM_MEANING_PM_AC_DISCONNECTED},
    {0x08,0x03,0x00,0x00, ST_ALARM_MEANING_PM_AC_REDISCONNECT},
    {0x08,0x03,0x01,0x61, ST_ALARM_MEANING_PM_AC_REDISCONNECT},
    {0x08,0x04,0x00,0x00, ST_ALARM_MEANING_PM_SURGE_DETECTED},
    {0x08,0x04,0x01,0x61, ST_ALARM_MEANING_PM_SURGE_DETECTED},
    {0x08,0x05,0x00,0x00, ST_ALARM_MEANING_PM_VOTAGE_DROP_DRIFT},
    {0x08,0x05,0x01,0x61, ST_ALARM_MEANING_PM_VOTAGE_DROP_DRIFT},
    {0x08,0x06,0x00,0x00, ST_ALARM_MEANING_PM_OVERCURRENT_DETECTED},
    {0x08,0x06,0x01,0x01, ST_ALARM_MEANING_PM_OVERCURRENT_DETECTED},
    {0x08,0x07,0x00,0x00, ST_ALARM_MEANING_PM_OVERVOTAGE_DETECTED},
    {0x08,0x07,0x01,0x01, ST_ALARM_MEANING_PM_OVERVOTAGE_DETECTED},
    {0x08,0x08,0x00,0x00, ST_ALARM_MEANING_PM_OVERLOAD_DETECTED},
    {0x08,0x08,0x01,0x01, ST_ALARM_MEANING_PM_OVERLOAD_DETECTED},
    {0x08,0x09,0x00,0x00, ST_ALARM_MEANING_PM_LOAD_ERROR},
    {0x08,0x09,0x01,0x01, ST_ALARM_MEANING_PM_LOAD_ERROR},  
    {0x08,0x0A,0x00,0x00, ST_ALARM_MEANING_PM_REPLACE_BATTERY_SOON},  
    {0x08,0x0A,0x01,0x61, ST_ALARM_MEANING_PM_REPLACE_BATTERY_SOON},
    {0x08,0x0B,0x00,0x00, ST_ALARM_MEANING_PM_REPLACE_BATTERY_NOW},
    {0x08,0x0B,0x01,0x61, ST_ALARM_MEANING_PM_REPLACE_BATTERY_NOW},
    {0x08,0x0C,0x00,0x00, ST_ALARM_MEANING_PM_BATTERY_CHARGING},
    {0x08,0x0C,0x01,0x61, ST_ALARM_MEANING_PM_BATTERY_CHARGING},
    {0x08,0x0D,0x00,0x00, ST_ALARM_MEANING_PM_BATTERY_FULLY_CHARGED},
    {0x08,0x0D,0x00,0x00, ST_ALARM_MEANING_PM_BATTERY_FULLY_CHARGED},
    {0x08,0x0E,0x01,0x61, ST_ALARM_MEANING_PM_CHARGE_BATTERY_SOON},
    {0x08,0x0E,0x00,0x00, ST_ALARM_MEANING_PM_CHARGE_BATTERY_SOON},
    {0x08,0x0F,0x00,0x00, ST_ALARM_MEANING_PM_CHARGE_BATTERY_NOW},
    {0x08,0x0F,0x01,0x61, ST_ALARM_MEANING_PM_CHARGE_BATTERY_NOW},
    {0x08,0x10,0x00,0x00, ST_ALARM_MEANING_PM_BACKUP_BATTERY_LOW},
    {0x08,0x10,0x00,0x00, ST_ALARM_MEANING_PM_BACKUP_BATTERY_LOW},
    {0x08,0x11,0x01,0x61, ST_ALARM_MEANING_PM_BATTERY_FLUID_LOW},
    {0x08,0x11,0x00,0x00, ST_ALARM_MEANING_PM_BATTERY_FLUID_LOW},
    {0x08,0xFE,0x00,0x00, ST_ALARM_MEANING_PM_UNKHOWN_EVENT_STATE},
    {0x08,0xFE,0x01,0x61, ST_ALARM_MEANING_PM_UNKHOWN_EVENT_STATE},
    {0x08,0xFF,0x00,0x00, "unknown"},
    {0x08,0xFF,0x00,0x00, "unknown"},
    //SYSTEM 
    {0x09,0x00,0x00,0x00, ST_ALARM_MEANING_SYSTEM_STATE_IDLE},
    {0x09,0x01,0x00,0x00, ST_ALARM_MEANING_SYSTEM_HARDWARE_FAILLURE},
    {0x09,0x01,0x01,0x61, ST_ALARM_MEANING_SYSTEM_HARDWARE_FAILLURE},
    {0x09,0x02,0x00,0x00, ST_ALARM_MEANING_SYSTEM_SOFTWARE_FAILURE},
    {0x09,0x02,0x01,0x61, ST_ALARM_MEANING_SYSTEM_SOFTWARE_FAILURE},
    {0x09,0x03,0x00,0x00, ST_ALARM_MEANING_SYSTEM_HARDWARE_FAILLURE_MANUFACTUER},
    {0x09,0x03,0x01,0x61, ST_ALARM_MEANING_SYSTEM_HARDWARE_FAILLURE_MANUFACTUER},
    {0x09,0x04,0x00,0x00, ST_ALARM_MEANING_SYSTEM_SOFTWARE_FAILURE_MANUFACTURE},
    {0x09,0x04,0x01,0x61, ST_ALARM_MEANING_SYSTEM_SOFTWARE_FAILURE_MANUFACTURE},
    {0x09,0x05,0x00,0x00, ST_ALARM_MEANING_SYSTEM_HEART_BEAT},
    {0x09,0x05,0x01,0x61, ST_ALARM_MEANING_SYSTEM_HEART_BEAT},
    {0x09,0x06,0x00,0x00, ST_ALARM_MEANING_SYSTEM_TEMPERATING_PRODUCT_REMOVE},
    {0x09,0x06,0x01,0x61, ST_ALARM_MEANING_SYSTEM_TEMPERATING_PRODUCT_REMOVE},
    {0x09,0x07,0x00,0x00, ST_ALARM_MEANING_SYSTEM_EMERGENCY_SHUTOFF},
    {0x09,0x07,0x01,0x61, ST_ALARM_MEANING_SYSTEM_EMERGENCY_SHUTOFF}, 
    {0x09,0xFE,0x00,0x00, ST_ALARM_MEANING_SYSTEM_UNKHOWN_EVENT_STATE},  
    {0x09,0xFE,0x01,0x61, ST_ALARM_MEANING_SYSTEM_UNKHOWN_EVENT_STATE},
    {0x09,0xFF,0x00,0x00, "unknown"},
    //EMERNGCY ALARM
    {0x0A,0x00,0x00,0x00, ST_ALARM_MEANING_EMERGENCY_STATE_IDLE},
    {0x0A,0x01,0x00,0x00, ST_ALARM_MEANING_EMERGENCY_CONTACT_POLICE},
    {0x0A,0x01,0x01,0x61, ST_ALARM_MEANING_EMERGENCY_CONTACT_POLICE},
    {0x0A,0x02,0x00,0x00, ST_ALARM_MEANING_EMERGENCY_CONTACT_FIRE_SERVICE},
    {0x0A,0x02,0x01,0x61, ST_ALARM_MEANING_EMERGENCY_CONTACT_FIRE_SERVICE},
    {0x0A,0x03,0x00,0x00, ST_ALARM_MEANING_EMERGENCY_CONTACT_MEDICAL_SERVICE},
    {0x0A,0x03,0x01,0x61, ST_ALARM_MEANING_EMERGENCY_CONTACT_MEDICAL_SERVICE}, 
    {0x0A,0xFE,0x00,0x00, ST_ALARM_MEANING_EMERGENCY_UNKHOWN_EVENT_STATE},  
    {0x0A,0xFE,0x01,0x61, ST_ALARM_MEANING_EMERGENCY_UNKHOWN_EVENT_STATE},
    {0x0A,0xFF,0x00,0x00, "unknown"}, 
    //CLOCK
    {0x0B,0x00,0x00,0x00, ST_ALARM_MEANING_CLOCK_STATE_IDLE},
    {0x0B,0x01,0x00,0x00, ST_ALARM_MEANING_CLOCK_WAKE_UP_ALERT},
    {0x0B,0x01,0x01,0x61, ST_ALARM_MEANING_CLOCK_WAKE_UP_ALERT},
    {0x0B,0x02,0x00,0x00, ST_ALARM_MEANING_CLOCK_TIMER_ENDED},
    {0x0B,0x02,0x01,0x61, ST_ALARM_MEANING_CLOCK_TIMER_ENDED},
    {0x0B,0x03,0x00,0x00, ST_ALARM_MEANING_CLOCK_TIME_REMAINING},
    {0x0B,0x03,0x01,0x01, "time remaining 1 hour 112 minutes 101 seconds"}, 
    {0x0B,0xFE,0x00,0x00, ST_ALARM_MEANING_CLOCK_UNKHOWN_EVENT_STATE},  
    {0x0B,0xFE,0x01,0x61, ST_ALARM_MEANING_CLOCK_UNKHOWN_EVENT_STATE},
    {0x0B,0xFF,0x00,0x00, "unknown"}, 
    //APPLIANCE
    {0x0C,0x00,0x00,0x00, ST_ALARM_MEANING_APP_STATE_IDLE},
    {0x0C,0x01,0x00,0x00, ST_ALARM_MEANING_APP_PROGRAM_STARTED},
    {0x0C,0x01,0x01,0x61, ST_ALARM_MEANING_APP_PROGRAM_STARTED},
    {0x0C,0x02,0x00,0x00, ST_ALARM_MEANING_APP_PROGRAM_PROGRESS},
    {0x0C,0x02,0x01,0x61, ST_ALARM_MEANING_APP_PROGRAM_PROGRESS},
    {0x0C,0x03,0x00,0x00, ST_ALARM_MEANING_APP_PROGRAM_COMPLETED},
    {0x0C,0x03,0x01,0x61, ST_ALARM_MEANING_APP_PROGRAM_COMPLETED},
    {0x0C,0x04,0x00,0x00, ST_ALARM_MEANING_APP_REPLACE_MAIN_FILTER},
    {0x0C,0x04,0x01,0x61, ST_ALARM_MEANING_APP_REPLACE_MAIN_FILTER},
    {0x0C,0x05,0x00,0x00, ST_ALARM_MEANING_APP_FAILURE_SET_TARGET_TEMPERATURE},
    {0x0C,0x05,0x01,0x61, ST_ALARM_MEANING_APP_FAILURE_SET_TARGET_TEMPERATURE},
    {0x0C,0x06,0x00,0x00, ST_ALARM_MEANING_APP_SUPPLYING_WATER},
    {0x0C,0x06,0x01,0x01, ST_ALARM_MEANING_APP_SUPPLYING_WATER},
    {0x0C,0x07,0x00,0x00, ST_ALARM_MEANING_APP_WATTER_SUPPLY_FAILURE},
    {0x0C,0x07,0x01,0x01, ST_ALARM_MEANING_APP_WATTER_SUPPLY_FAILURE},
    {0x0C,0x08,0x00,0x00, ST_ALARM_MEANING_APP_BOILLING},
    {0x0C,0x08,0x01,0x01, ST_ALARM_MEANING_APP_BOILLING},
    {0x0C,0x09,0x00,0x00, ST_ALARM_MEANING_APP_BOILLING_FAILURE},
    {0x0C,0x09,0x01,0x01, ST_ALARM_MEANING_APP_BOILLING_FAILURE},  
    {0x0C,0x0A,0x00,0x00, ST_ALARM_MEANING_APP_WASHING},  
    {0x0C,0x0A,0x01,0x61, ST_ALARM_MEANING_APP_WASHING},
    {0x0C,0x0B,0x00,0x00, ST_ALARM_MEANING_APP_WASHING_FAILURE},
    {0x0C,0x0B,0x01,0x61, ST_ALARM_MEANING_APP_WASHING_FAILURE},
    {0x0C,0x0C,0x00,0x00, ST_ALARM_MEANING_APP_RINSING},
    {0x0C,0x0C,0x01,0x61, ST_ALARM_MEANING_APP_RINSING},
    {0x0C,0x0D,0x00,0x00, ST_ALARM_MEANING_APP_RINSING_FAILURE},
    {0x0C,0x0D,0x01,0x61, ST_ALARM_MEANING_APP_RINSING_FAILURE},
    {0x0C,0x0E,0x00,0x00, ST_ALARM_MEANING_APP_DRAINING},
    {0x0C,0x0E,0x01,0x61, ST_ALARM_MEANING_APP_DRAINING},
    {0x0C,0x0F,0x00,0x00, ST_ALARM_MEANING_APP_DRAINING_FAILURE},
    {0x0C,0x0F,0x01,0x61, ST_ALARM_MEANING_APP_DRAINING_FAILURE},
    {0x0C,0x10,0x00,0x00, ST_ALARM_MEANING_APP_SPINNING},
    {0x0C,0x10,0x01,0x61, ST_ALARM_MEANING_APP_SPINNING},
    {0x0C,0x11,0x00,0x00, ST_ALARM_MEANING_APP_SPINNING_FAILURE},
    {0x0C,0x11,0x01,0x61, ST_ALARM_MEANING_APP_SPINNING_FAILURE},
    {0x0C,0x12,0x00,0x00, ST_ALARM_MEANING_APP_DRYING},
    {0x0C,0x12,0x01,0x61, ST_ALARM_MEANING_APP_DRYING},
    {0x0C,0x13,0x00,0x00, ST_ALARM_MEANING_APP_DRYING_FAILURE},
    {0x0C,0x13,0x01,0x61, ST_ALARM_MEANING_APP_DRYING_FAILURE},
    {0x0C,0x14,0x00,0x00, ST_ALARM_MEANING_APP_FAN_FAILURE},
    {0x0C,0x14,0x01,0x61, ST_ALARM_MEANING_APP_FAN_FAILURE},
    {0x0C,0x15,0x00,0x00, ST_ALARM_MEANING_APP_COMPRESSOR_FAILURE},
    {0x0C,0x15,0x01,0x61, ST_ALARM_MEANING_APP_COMPRESSOR_FAILURE},
    {0x0C,0xFE,0x00,0x00, ST_ALARM_MEANING_APP_UNKHOWN_EVENT_STATE},
    {0x0C,0xFE,0x01,0x61, ST_ALARM_MEANING_APP_UNKHOWN_EVENT_STATE},
    {0x0C,0xFF,0x00,0x00, "unknown"},
    {0x0C,0xFF,0x00,0x00, "unknown"},
    //HOME HEATH
    {0x0D,0x00,0x00,0x00, ST_ALARM_MEANING_HOME_HEALTH_STATE_IDLE},
    {0x0D,0x01,0x00,0x00, ST_ALARM_MEANING_HOME_HEALTH_LEAVING_BED},
    {0x0D,0x01,0x01,0x61, ST_ALARM_MEANING_HOME_HEALTH_LEAVING_BED},
    {0x0D,0x02,0x00,0x00, ST_ALARM_MEANING_HOME_HEALTH_SITTING_ON_BED},
    {0x0D,0x02,0x01,0x61, ST_ALARM_MEANING_HOME_HEALTH_SITTING_ON_BED},
    {0x0D,0x03,0x00,0x00, ST_ALARM_MEANING_HOME_HEALTH_LYING_ON_BED},
    {0x0D,0x03,0x01,0x61, ST_ALARM_MEANING_HOME_HEALTH_LYING_ON_BED},
    {0x0D,0x04,0x00,0x00, ST_ALARM_MEANING_HOME_HEALTH_POSTURE_CHANGED},
    {0x0D,0x04,0x01,0x61, ST_ALARM_MEANING_HOME_HEALTH_POSTURE_CHANGED},
    {0x0D,0x05,0x00,0x00, ST_ALARM_MEANING_HOME_HEALTH_SITTING_ON_BED_ADGE},
    {0x0D,0x05,0x01,0x61, ST_ALARM_MEANING_HOME_HEALTH_SITTING_ON_BED_ADGE},
    {0x0D,0x06,0x00,0x00, "unknown"},
    {0x0D,0x06,0x01,0x01, ST_ALARM_MEANING_HOME_HEALTH_VOLATILE_ORGANIC_CLEAN},
    {0x0D,0x06,0x01,0x02, ST_ALARM_MEANING_HOME_HEALTH_VOLATILE_ORGANIC_SLIGHTLY},
    {0x0D,0x06,0x01,0x03, ST_ALARM_MEANING_HOME_HEALTH_VOLATILE_ORGANIC_MODERATELY},
    {0x0D,0x06,0x01,0x04, ST_ALARM_MEANING_HOME_HEALTH_VOLATILE_ORGANIC_HIGHLY},
    {0x0D,0x06,0x01,0x05, "unknown"},
    {0x0D,0x07,0x01,0x02, "unknown"},
    {0x0D,0xFE,0x00,0x00, ST_ALARM_MEANING_HOME_HEALTH_UNKHOWN_EVENT_STATE},  
    {0x0D,0xFE,0x01,0x61, ST_ALARM_MEANING_HOME_HEALTH_UNKHOWN_EVENT_STATE},
    {0x0D,0xFF,0x00,0x00, "unknown"},
    //SIREN
    {0x0E,0x00,0x00,0x00, ST_ALARM_MEANING_SIREN_STATE_IDLE},
    {0x0E,0x01,0x00,0x00, ST_ALARM_MEANING_SIREN_ACTIVE},
    {0x0E,0x01,0x01,0x61, ST_ALARM_MEANING_SIREN_ACTIVE},
    {0x0E,0x02,0x00,0x00, "unknown"},
    {0x0E,0x02,0x01,0x61, "unknown"},
    {0x0E,0xFE,0x00,0x00, ST_ALARM_MEANING_SIREN_UNKHOWN_EVENT_STATE},
    {0x0E,0xFE,0x01,0x61, ST_ALARM_MEANING_SIREN_UNKHOWN_EVENT_STATE},
    {0x0E,0xFF,0x00,0x00, "unknown"},
    //WATER VALVE
    {0x0F,0x00,0x00,0x00, ST_ALARM_MEANING_WATER_VALVE_STATE_IDLE},
    {0x0F,0x01,0x00,0x00, "unknown"},
    {0x0F,0x01,0x01,0x00, ST_ALARM_MEANING_WATER_VALVE_OPERATION_OFF},
    {0x0F,0x01,0x01,0x01, ST_ALARM_MEANING_WATER_VALVE_OPERATION_ON},
    {0x0F,0x01,0x01,0x02, "unknown"},
    {0x0F,0x02,0x00,0x00, "unknown"},
    {0x0F,0x02,0x01,0x00, ST_ALARM_MEANING_WATER_MASTER_VALVE_OPERATION_OFF},
    {0x0F,0x02,0x01,0x01, ST_ALARM_MEANING_WATER_MASTER_VALVE_OPERATION_ON},
    {0x0F,0x02,0x01,0x61, "unknown"},
    {0x0F,0x03,0x00,0x00, ST_ALARM_MEANING_WATER_VALVE_SHORT_CIRCUIT},
    {0x0F,0x03,0x01,0x61, ST_ALARM_MEANING_WATER_VALVE_SHORT_CIRCUIT},
    {0x0F,0x04,0x00,0x00, ST_ALARM_MEANING_WATER_MASTER_VALVE_SHORT_CIRCUIT},
    {0x0F,0x04,0x01,0x61, ST_ALARM_MEANING_WATER_MASTER_VALVE_SHORT_CIRCUIT},
    {0x0F,0x05,0x00,0x00, ST_ALARM_MEANING_WATER_VALVE_CURRENT_ALARM},
    {0x0F,0x05,0x00,0x01, ST_ALARM_MEANING_WATER_VALVE_CURRENT_ALARM},
    {0x0F,0x05,0x01,0x00, "unknown"},
    {0x0F,0x05,0x01,0x01, ST_ALARM_MEANING_WATER_VALVE_CURRENT_ALARM_NODATA},
    {0x0F,0x05,0x01,0x02, ST_ALARM_MEANING_WATER_VALVE_CURRENT_ALARM_LOW_THRESHOLD},
    {0x0F,0x05,0x01,0x03, ST_ALARM_MEANING_WATER_VALVE_CURRENT_ALARM_HIGH_THRESHOLD},
    {0x0F,0x05,0x01,0x04, ST_ALARM_MEANING_WATER_VALVE_CURRENT_ALARM_MAX},
    {0x0F,0x05,0x01,0x05, "unknown"},
    {0x0F,0x06,0x00,0x00, ST_ALARM_MEANING_WATER_MASTER_VALVE_CURRENT_ALARM},
    {0x0F,0x06,0x01,0x01, ST_ALARM_MEANING_WATER_MASTER_VALVE_CURRENT_ALARM_NODATA},
    {0x0F,0x06,0x01,0x02, ST_ALARM_MEANING_WATER_MASTER_VALVE_CURRENT_ALARM_LOW_THRESHOLD},
    {0x0F,0x06,0x01,0x03, ST_ALARM_MEANING_WATER_MASTER_VALVE_CURRENT_ALARM_HIGH_THRESHOLD},
    {0x0F,0x06,0x01,0x04, ST_ALARM_MEANING_WATER_MASTER_VALVE_CURRENT_ALARM_MAX},
    {0x0F,0x06,0x01,0x05, "unknown"},
    {0x0F,0x06,0x00,0x05, ST_ALARM_MEANING_WATER_MASTER_VALVE_CURRENT_ALARM},
    {0x0F,0xFE,0x00,0x00, ST_ALARM_MEANING_WATER_VALVE_UNKHOWN_EVENT_STATE},
    {0x0F,0xFE,0x01,0x61, ST_ALARM_MEANING_WATER_VALVE_UNKHOWN_EVENT_STATE},
    {0x0F,0xFF,0x00,0x00, "unknown"},
    {0x0F,0xFF,0x00,0x00, "unknown"},
    //Weather Alarm
    {0x10,0x00,0x00,0x00, ST_ALARM_MEANING_WEATHER_STATE_IDLE},
    {0x10,0x01,0x00,0x00, ST_ALARM_MEANING_WEATHER_RAIN_ALARM},
    {0x10,0x01,0x01,0x61, ST_ALARM_MEANING_WEATHER_RAIN_ALARM},
    {0x10,0x02,0x00,0x00, ST_ALARM_MEANING_WEATHER_MOISTURE_ALARM},
    {0x10,0x02,0x01,0x61, ST_ALARM_MEANING_WEATHER_MOISTURE_ALARM},
    {0x10,0x03,0x00,0x00, ST_ALARM_MEANING_WEATHER_FREEZE_ALARM},
    {0x10,0x03,0x01,0x61, ST_ALARM_MEANING_WEATHER_FREEZE_ALARM},
    {0x10,0x04,0x00,0x00, "unknown"},
    {0x10,0x04,0x01,0x61, "unknown"},
    {0x10,0xFE,0x00,0x00, ST_ALARM_MEANING_WEATHER_UNKHOWN_EVENT_STATE},
    {0x10,0xFE,0x01,0x61, ST_ALARM_MEANING_WEATHER_UNKHOWN_EVENT_STATE},
    {0x10,0xFF,0x00,0x00, "unknown"},
    {0x10,0xFF,0x00,0x00, "unknown"},
    //Irrigation
    {0x11,0x00,0x00,0x00, ST_ALARM_MEANING_IRRIGATION_STATE_IDLE},
    {0x11,0x01,0x00,0x00, ST_ALARM_MEANING_IRRIGATION_SCHEDULE_STARTED},
    {0x11,0x01,0x01,0x61, ST_ALARM_MEANING_IRRIGATION_SCHEDULE_STARTED},
    {0x11,0x02,0x00,0x00, ST_ALARM_MEANING_IRRIGATION_SCHEDULE_FINISHED},
    {0x11,0x02,0x01,0x61, ST_ALARM_MEANING_IRRIGATION_SCHEDULE_FINISHED},
    {0x11,0x03,0x00,0x00, ST_ALARM_MEANING_IRRIGATION_VALVE_TABLE_RUN_STARTED},
    {0x11,0x03,0x01,0x61, ST_ALARM_MEANING_IRRIGATION_VALVE_TABLE_RUN_STARTED},
    {0x11,0x04,0x00,0x00, ST_ALARM_MEANING_IRRIGATION_VALVE_TABLE_RUN_FINISHED},
    {0x11,0x04,0x01,0x61, ST_ALARM_MEANING_IRRIGATION_VALVE_TABLE_RUN_FINISHED},
    {0x11,0x05,0x00,0x00, ST_ALARM_MEANING_IRRIGATION_DEVICE_NOT_CONFIGURED},
    {0x11,0x05,0x01,0x61, ST_ALARM_MEANING_IRRIGATION_DEVICE_NOT_CONFIGURED},
    {0x11,0x06,0x00,0x00, "unknown"},
    {0x11,0x06,0x01,0x61, "unknown"},     
    {0x11,0xFE,0x00,0x00, ST_ALARM_MEANING_IRRIGATION_UNKHOWN_EVENT_STATE},
    {0x11,0xFE,0x01,0x61, ST_ALARM_MEANING_IRRIGATION_UNKHOWN_EVENT_STATE},
    {0x11,0xFF,0x00,0x00, "unknown"},
    {0x11,0xFF,0x00,0x00, "unknown"},
    //Gas alarm
    {0x12,0x00,0x00,0x00, ST_ALARM_MEANING_GAS_STATE_IDLE},
    {0x12,0x01,0x00,0x00, ST_ALARM_MEANING_GAS_COMBUSTIBLE_GAS_DETECTED_LOCATION},
    {0x12,0x01,0x01,0x61, "combustible gas detected at location a"},
    {0x12,0x02,0x00,0x00, ST_ALARM_MEANING_GAS_COMBUSTIBLE_GAS_DETECTED},
    {0x12,0x02,0x01,0x61, ST_ALARM_MEANING_GAS_COMBUSTIBLE_GAS_DETECTED},
    {0x12,0x03,0x00,0x00, ST_ALARM_MEANING_GAS_TOXIC_GAS_DETECTED_LOCATION},
    {0x12,0x03,0x01,0x61, "toxic gas detected at location a"},
    {0x12,0x04,0x00,0x00, ST_ALARM_MEANING_GAS_TOXIC_GAS_DETECTED},
    {0x12,0x04,0x01,0x61, ST_ALARM_MEANING_GAS_TOXIC_GAS_DETECTED},
    {0x12,0x05,0x00,0x00, ST_ALARM_MEANING_GAS_ALARM_TEST},
    {0x12,0x05,0x01,0x61, ST_ALARM_MEANING_GAS_ALARM_TEST},
    {0x12,0x06,0x00,0x00, ST_ALARM_MEANING_GAS_REPLACEMENT_REQUIRED},
    {0x12,0x06,0x01,0x61, ST_ALARM_MEANING_GAS_REPLACEMENT_REQUIRED},  
    {0x12,0xFE,0x00,0x00, ST_ALARM_MEANING_GAS_UNKHOWN_EVENT_STATE},
    {0x12,0xFE,0x01,0x61, ST_ALARM_MEANING_GAS_UNKHOWN_EVENT_STATE},
    {0x12,0xFF,0x00,0x00, "unknown"},
    {0x12,0xFF,0x00,0x00, "unknown"},
    //Pest Control
    {0x13,0x00,0x00,0x00, ST_ALARM_MEANING_PEST_STATE_IDLE},
    {0x13,0x01,0x00,0x00, ST_ALARM_MEANING_PEST_TRAP_ARMED_LOCATION},
    {0x13,0x01,0x01,0x61, "trap armed at location a"},
    {0x13,0x02,0x00,0x00, ST_ALARM_MEANING_PEST_TRAP_ARMED},
    {0x13,0x02,0x01,0x61, ST_ALARM_MEANING_PEST_TRAP_ARMED},
    {0x13,0x03,0x00,0x00, ST_ALARM_MEANING_PEST_TRAP_REARMED_REQUIRED_LOCATION},
    {0x13,0x03,0x01,0x61, "trap re-arm required at location a"},
    {0x13,0x04,0x00,0x00, ST_ALARM_MEANING_PEST_TRAP_REARMED_REQUIRED},
    {0x13,0x04,0x01,0x61, ST_ALARM_MEANING_PEST_TRAP_REARMED_REQUIRED},
    {0x13,0x05,0x00,0x00, ST_ALARM_MEANING_PEST_DETECTED_LOCATION},
    {0x13,0x05,0x01,0x61, "pest detected at location a"},
    {0x13,0x06,0x00,0x00, ST_ALARM_MEANING_PEST_DETECTED},
    {0x13,0x06,0x01,0x61, ST_ALARM_MEANING_PEST_DETECTED},
    {0x13,0x07,0x00,0x00, ST_ALARM_MEANING_PEST_EXTERMINATED_LOCATION},
    {0x13,0x07,0x01,0x61, "pest exterminated at location a"}, 
    {0x13,0x08,0x00,0x00, ST_ALARM_MEANING_PEST_EXTERMINATED},
    {0x13,0x08,0x01,0x61, ST_ALARM_MEANING_PEST_EXTERMINATED},       
    {0x13,0xFE,0x00,0x00, ST_ALARM_MEANING_PEST_UNKHOWN_EVENT_STATE},
    {0x13,0xFE,0x01,0x61, ST_ALARM_MEANING_PEST_UNKHOWN_EVENT_STATE},
    {0x13,0xFF,0x00,0x00, "unknown"},
    {0x13,0xFF,0x00,0x00, "unknown"},  
};

extern void try_to_parser_alarm_info(json_object *jobj, cmd_class_notify_t *data);

static void verify_notification_meaning(table_parser_t table[],uint16_t table_len)
{
    //compare type name and type event
    char *result = NULL;
    json_object *jobj = json_object_new_object();
    json_object *jobj_convert;
    cmd_class_notify_t *data = malloc(sizeof(cmd_class_notify_t));
    data->version = 3;
    int i = 0;
    int j = 0;
    table_result_t table_result[table_len];

    for (i = 0; i < table_len; ++i)
    {
        data->notification_report.zwave_alarm_type = table[i].zwave_alarm_type;
        data->notification_report.zwave_alarm_event = table[i].zwave_alarm_event;
        data->notification_report.no_event_params = table[i].no_event_params;
        data->notification_report.event_param[0] = table[i].event_param;
        try_to_parser_alarm_info(jobj, data);
        jobj_convert = json_object_object_get(jobj, "alarmMeaning");
        result = (char *)json_object_get_string(jobj_convert);
        if (strcmp(result,table[i].expected))
        {   
            switch (table[i].zwave_alarm_type)
            {   
                case 0x01:
                {
                    table_result[j].lable = "Test case Smoke control";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;
                    break;
                }
                case 0x02:
                {
                    table_result[j].lable = "Test case CO Alarm";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;
                    break;
                }
                case 0x03:
                {
                    table_result[j].lable = "Test case CO2 Alarm";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;            
                    break;
                }
                case 0x04:
                {
                    table_result[j].lable = "Test case Heat Alarm";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;            
                break;
                }
                case 0x05:
                {
                    table_result[j].lable = "Test case Water Alarm";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;        
                    break;
                }
                case 0x06:
                {
                    table_result[j].lable = "Test case Access control";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;            
                    break;
                }
                case 0x07:
                {
                    table_result[j].lable = "Test case Home Security";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;            
                    break;
                }
                case 0x08:
                {
                    table_result[j].lable = "Test case Power Management";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;
                    break;
                }
                case 0x09:
                {
                    table_result[j].lable = "Test case System";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;            
                    break;
                }
                case 0x0A:
                {
                    table_result[j].lable = "Test case Emergency Alarm";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;        
                    break;
                }
                case 0x0B:
                {
                    table_result[j].lable = "Test case Clock";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;            
                    break;
                }
                case 0x0C:
                {
                    table_result[j].lable = "Test case Appliance";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;            
                    break;
                }
                case 0x0D:
                {
                    table_result[j].lable = "Test case Home Health";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;        
                    break;
                }
                case 0x0E:
                {
                    table_result[j].lable = "Test case Siren";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;            
                    break;
                }
                case 0x0F:
                {
                    table_result[j].lable = "Test case Water Valve";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;                
                    break;
                }
                case 0x10:
                {
                    table_result[j].lable = "Test case Weather Alarm";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;            
                    break;
                }
                case 0x11:
                {
                    table_result[j].lable = "Test case Irrigation";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;            
                    break;
                }
                case 0x12:
                {
                    table_result[j].lable = "Test case Gas Alarm";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;        
                    break;
                }
                case 0x13:
                {
                    table_result[j].lable = "Test case Pest control";
                    table_result[j].id = i;
                    table_result[j].actual = (char *)malloc(strlen(result) + 1);
                    strcpy(table_result[j].actual, result); 
                    j++;;           
                    break;
                }
                case 0xFF:
                {
                    break;
                }
            }       
        } 
    }

    uint16_t pos_failed;
    printf("NUMBER TEST CASE FAILED : %d \n",j);
    for (i = 0; i < j; ++i)
    {
        pos_failed = table_result[i].id;
        printf("Name type: %s\n", table_result[i].lable);
        printf("Input: %02X %02X %02X %02X\n",table[pos_failed].zwave_alarm_type, table[pos_failed].zwave_alarm_event,
                table[pos_failed].no_event_params, table[pos_failed].event_param);
        printf("Expected: %s\n", table[pos_failed].expected);
        printf("Actual: %s\n", table_result[i].actual);
        free(table_result[i].actual);
    }

    json_object_put(jobj);
    free(data);
}

int test_notification()
{ 
    uint16_t table_len = sizeof(test_case_notification)/sizeof(table_parser_t);
    verify_notification_meaning(test_case_notification, table_len);
    return 0;
}